﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;

namespace WobbrockLib.Controls
{
	/// <summary>
	/// Provides a data grid view control whose painting is double-buffered to reduce flicker.
	/// </summary>
	[ToolboxBitmap(typeof(System.Windows.Forms.DataGridView))]
	public partial class DoubleBufferedDataGridView : DataGridView
	{
		/// <summary>
		/// Constructor.
		/// </summary>
		public DoubleBufferedDataGridView()
			: this(null)
		{
			// do nothing
		}

		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="container">The container for this control.</param>
		public DoubleBufferedDataGridView(IContainer container)
		{
			container?.Add(this);
			InitializeComponent();
			this.SetStyle(
				ControlStyles.OptimizedDoubleBuffer |
				ControlStyles.AllPaintingInWmPaint |
				ControlStyles.UserPaint,
				true);
		}
	}
}
